Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.Designer.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.Designer.cs	(revision 7445)
@@ -0,0 +1,162 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views {
+  partial class GeneralizedQuadraticAssignmentProblemView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.label1 = new System.Windows.Forms.Label();
+      this.problemInstanceProviderComboBox = new System.Windows.Forms.ComboBox();
+      this.instancesComboBox = new System.Windows.Forms.ComboBox();
+      this.loadButton = new System.Windows.Forms.Button();
+      this.label2 = new System.Windows.Forms.Label();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Location = new System.Drawing.Point(0, 58);
+      this.parameterCollectionView.Size = new System.Drawing.Size(650, 394);
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Location = new System.Drawing.Point(50, 32);
+      this.nameTextBox.Size = new System.Drawing.Size(578, 20);
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.Location = new System.Drawing.Point(3, 35);
+      // 
+      // infoLabel
+      // 
+      this.infoLabel.Location = new System.Drawing.Point(634, 35);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 8);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(41, 13);
+      this.label1.TabIndex = 4;
+      this.label1.Text = "Library:";
+      // 
+      // problemInstanceProviderComboBox
+      // 
+      this.problemInstanceProviderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.problemInstanceProviderComboBox.FormattingEnabled = true;
+      this.problemInstanceProviderComboBox.Location = new System.Drawing.Point(50, 5);
+      this.problemInstanceProviderComboBox.Name = "problemInstanceProviderComboBox";
+      this.problemInstanceProviderComboBox.Size = new System.Drawing.Size(173, 21);
+      this.problemInstanceProviderComboBox.TabIndex = 5;
+      this.problemInstanceProviderComboBox.SelectedIndexChanged += new System.EventHandler(this.problemInstanceProviderComboBox_SelectedIndexChanged);
+      this.problemInstanceProviderComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
+      // 
+      // instancesComboBox
+      // 
+      this.instancesComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.instancesComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.instancesComboBox.FormattingEnabled = true;
+      this.instancesComboBox.Location = new System.Drawing.Point(286, 5);
+      this.instancesComboBox.Name = "instancesComboBox";
+      this.instancesComboBox.Size = new System.Drawing.Size(283, 21);
+      this.instancesComboBox.TabIndex = 5;
+      this.instancesComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
+      // 
+      // loadButton
+      // 
+      this.loadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.loadButton.Location = new System.Drawing.Point(575, 3);
+      this.loadButton.Name = "loadButton";
+      this.loadButton.Size = new System.Drawing.Size(75, 23);
+      this.loadButton.TabIndex = 6;
+      this.loadButton.Text = "Load";
+      this.loadButton.UseVisualStyleBackColor = true;
+      this.loadButton.Click += new System.EventHandler(this.loadButton_Click);
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(229, 8);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(51, 13);
+      this.label2.TabIndex = 4;
+      this.label2.Text = "Instance:";
+      // 
+      // GeneralizedQuadraticAssignmentProblemView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.loadButton);
+      this.Controls.Add(this.problemInstanceProviderComboBox);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.instancesComboBox);
+      this.Controls.Add(this.label1);
+      this.Name = "GeneralizedQuadraticAssignmentProblemView";
+      this.Size = new System.Drawing.Size(653, 455);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      this.Controls.SetChildIndex(this.label1, 0);
+      this.Controls.SetChildIndex(this.instancesComboBox, 0);
+      this.Controls.SetChildIndex(this.label2, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.problemInstanceProviderComboBox, 0);
+      this.Controls.SetChildIndex(this.loadButton, 0);
+      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.ComboBox problemInstanceProviderComboBox;
+    private System.Windows.Forms.ComboBox instancesComboBox;
+    private System.Windows.Forms.Button loadButton;
+    private System.Windows.Forms.Label label2;
+
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.cs	(revision 7445)
@@ -0,0 +1,106 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views {
+  [View("GeneralizedQuadraticAssignmentProblemView")]
+  [Content(typeof(GeneralizedQuadraticAssignmentProblem), IsDefaultView = true)]
+  public partial class GeneralizedQuadraticAssignmentProblemView : ParameterizedNamedItemView {
+
+    public new GeneralizedQuadraticAssignmentProblem Content {
+      get { return (GeneralizedQuadraticAssignmentProblem)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public GeneralizedQuadraticAssignmentProblemView() {
+      InitializeComponent();
+      problemInstanceProviderComboBox.DisplayMember = "Name";
+      instancesComboBox.DisplayMember = "Name";
+      problemInstanceProviderComboBox.DataSource = GetProblemInstanceProviders().ToList();
+    }
+
+    #region Register Content Events
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      problemInstanceProviderComboBox.DataSource = GetProblemInstanceProviders().ToList();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+    }
+
+    #region Content Event Handlers
+    #endregion
+
+    #region Event Handlers
+    private void problemInstanceProviderComboBox_SelectedIndexChanged(object sender, System.EventArgs e) {
+      var provider = (IProblemInstanceProvider)problemInstanceProviderComboBox.SelectedItem;
+      instancesComboBox.DataSource = provider.GetInstanceDescriptors().ToList();
+    }
+
+    private void comboBox_DataSourceChanged(object sender, EventArgs e) {
+      var comboBox = (ComboBox)sender;
+      if (comboBox.DataSource == null)
+        comboBox.Items.Clear();
+    }
+
+    private void loadButton_Click(object sender, EventArgs e) {
+      var provider = (IProblemInstanceProvider)problemInstanceProviderComboBox.SelectedItem;
+      var descriptor = (IInstanceDescriptor)instancesComboBox.SelectedItem;
+      OnLoadProblemInstanceButtonClicked(provider, descriptor);
+    }
+    #endregion
+
+    #region Helpers
+    #endregion
+
+    protected virtual IEnumerable<IProblemInstanceProvider> GetProblemInstanceProviders() {
+      var qapProviders = ApplicationManager.Manager.GetInstances<IProblemInstanceProvider<IQAPInstance>>().Cast<IProblemInstanceProvider>();
+      var ctapProviders = ApplicationManager.Manager.GetInstances<IProblemInstanceProvider<ICTAPInstance>>().Cast<IProblemInstanceProvider>();
+      return qapProviders.Concat(ctapProviders);
+    }
+
+    protected virtual void OnLoadProblemInstanceButtonClicked(IProblemInstanceProvider provider, IInstanceDescriptor descriptor) {
+      if (provider is IProblemInstanceProvider<IQAPInstance>) {
+        Content.LoadFrom(((IProblemInstanceProvider<IQAPInstance>)provider).GetInstance(descriptor));
+      } else if (provider is IProblemInstanceProvider<ICTAPInstance>) {
+        Content.LoadFrom(((IProblemInstanceProvider<ICTAPInstance>)provider).GetInstance(descriptor));
+      }
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.resx
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.resx	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPProblemView.resx	(revision 7445)
@@ -0,0 +1,126 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>107, 17</value>
+  </metadata>
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
+</root>
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj	(revision 7445)
@@ -88,4 +88,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="GQAPProblemView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="GQAPProblemView.Designer.cs">
+      <DependentUpon>GQAPProblemView.cs</DependentUpon>
+    </Compile>
     <Compile Include="GQAPAssignmentArchiveView.cs">
       <SubType>UserControl</SubType>
@@ -113,6 +119,13 @@
       <Name>HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
+      <Project>{3540E29E-4793-49E7-8EE2-FEA7F61C3994}</Project>
+      <Name>HeuristicLab.Problems.Instances-3.3</Name>
+    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="GQAPProblemView.resx">
+      <DependentUpon>GQAPProblemView.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="GQAPAssignmentArchiveView.resx">
       <DependentUpon>GQAPAssignmentArchiveView.cs</DependentUpon>
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7445)
@@ -201,20 +201,45 @@
     }
 
-    public void LoadFrom(IQAPInstance format) {
-      Weights = new DoubleMatrix(format.Weights);
-      Distances = new DoubleMatrix(format.Distances);
-      InstallationCosts = new DoubleMatrix(Weights.Rows, Distances.Columns);
+    public void LoadFrom(IQAPInstance instance) {
+      Weights = new DoubleMatrix(instance.Weights);
+      Distances = new DoubleMatrix(instance.Distances);
+      InstallationCosts = new DoubleMatrix(Weights.Rows, Distances.Columns); // all zero
       Capacities = new DoubleArray(Enumerable.Range(0, Distances.Rows).Select(x => 1.0).ToArray());
       Demands = new DoubleArray(Enumerable.Range(0, Weights.Rows).Select(x => 1.0).ToArray());
 
-      if (format.BestKnownAssignment != null) {
-        var assignment = new IntegerVector(format.BestKnownAssignment);
-        double flowDistanceQuality, installationQuality, overbookedCapacity;
-        GQAPEvaluator.Evaluate(assignment, Weights, Distances, InstallationCosts, Demands, Capacities,
-          out flowDistanceQuality, out installationQuality, out overbookedCapacity);
-        double quality = GQAPEvaluator.GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity, TransportationCosts.Value, OverbookedCapacityPenalty.Value);
-        BestKnownSolution = new GQAPSolution(assignment, new DoubleValue(quality), new DoubleValue(flowDistanceQuality), new DoubleValue(installationQuality), new DoubleValue(overbookedCapacity));
-        BestKnownQuality = new DoubleValue(quality);
-      }
+      TransportationCosts.Value = 1;
+
+      if (instance.BestKnownAssignment != null) {
+        EvaluateAndLoadAssignment(instance.BestKnownAssignment);
+      }
+    }
+
+    public void LoadFrom(ICTAPInstance instance) {
+      Capacities = new DoubleArray(instance.MemoryCapacities);
+      Demands = new DoubleArray(instance.MemoryRequirements);
+      Weights = new DoubleMatrix(instance.CommunicationCosts);
+      InstallationCosts = new DoubleMatrix(instance.ExecutionCosts);
+      Distances = new DoubleMatrix(Capacities.Length, Capacities.Length); // all one, except diagonal
+      for (int i = 0; i < Capacities.Length - 1; i++)
+        for (int j = i + 1; j < Capacities.Length; j++) {
+          Distances[i, j] = 1;
+          Distances[j, i] = 1;
+        }
+
+      TransportationCosts.Value = 1;
+
+      if (instance.BestKnownAssignment != null) {
+        EvaluateAndLoadAssignment(instance.BestKnownAssignment);
+      }
+    }
+
+    private void EvaluateAndLoadAssignment(int[] vector) {
+      var assignment = new IntegerVector(vector);
+      double flowDistanceQuality, installationQuality, overbookedCapacity;
+      GQAPEvaluator.Evaluate(assignment, Weights, Distances, InstallationCosts, Demands, Capacities,
+        out flowDistanceQuality, out installationQuality, out overbookedCapacity);
+      double quality = GQAPEvaluator.GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity, TransportationCosts.Value, OverbookedCapacityPenalty.Value);
+      BestKnownSolution = new GQAPSolution(assignment, new DoubleValue(quality), new DoubleValue(flowDistanceQuality), new DoubleValue(installationQuality), new DoubleValue(overbookedCapacity));
+      BestKnownQuality = new DoubleValue(quality);
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstance.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstance.cs	(revision 7445)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  internal class ElloumiCTAPInstance : ICTAPInstance {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+    public double[,] ExecutionCosts { get; internal set; }
+    public double[,] CommunicationCosts { get; internal set; }
+    public double[] MemoryRequirements { get; internal set; }
+    public double[] MemoryCapacities { get; internal set; }
+    public int[] BestKnownAssignment { get; internal set; }
+    public double? BestKnownQuality { get; internal set; }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceDescriptor.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceDescriptor.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceDescriptor.cs	(revision 7445)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  internal class ElloumiCTAPInstanceDescriptor : IInstanceDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+    internal string SolutionIdentifier { get; set; }
+
+    internal ElloumiCTAPInstanceDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+      this.SolutionIdentifier = solutionIdentifier;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7445)
@@ -0,0 +1,95 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Reflection;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  public class ElloumiCTAPInstanceProvider : IProblemInstanceProvider<ICTAPInstance> {
+    public string Name {
+      get { return "Elloumi's CTAP instances"; }
+    }
+
+    public string Description {
+      get { return "CTAP instances published by Sourour Elloumi"; }
+    }
+
+    public Uri Link {
+      get { return new Uri("http://cedric.cnam.fr/oc/TAP/TAP.html"); }
+    }
+
+    public IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+      var solutions = Assembly.GetExecutingAssembly()
+        .GetManifestResourceNames()
+        .Where(x => x.EndsWith(".sol"))
+        .ToDictionary(x => Path.GetFileNameWithoutExtension(x) + ".dat", x => x);
+
+      return Assembly.GetExecutingAssembly()
+          .GetManifestResourceNames()
+          .Where(x => x.EndsWith(".dat"))
+          .OrderBy(x => x)
+          .Select(x => new ElloumiCTAPInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+    }
+
+    public ICTAPInstance GetInstance(IInstanceDescriptor id) {
+      var descriptor = (ElloumiCTAPInstanceDescriptor)id;
+      var instance = new ElloumiCTAPInstance();
+      using (var stream = Assembly.GetExecutingAssembly()
+        .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
+        ElloumiCTAPParser datParser = new ElloumiCTAPParser();
+        datParser.Parse(stream);
+        if (datParser.Error != null) throw datParser.Error;
+        instance.ExecutionCosts = datParser.ExecutionCosts;
+        instance.CommunicationCosts = datParser.CommunicationCosts;
+        instance.MemoryRequirements = datParser.MemoryRequirements;
+        instance.MemoryCapacities = datParser.MemoryCapacities;
+
+        instance.Name = id.Name;
+        instance.Description = id.Description;
+
+        if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
+          using (Stream solStream = Assembly.GetExecutingAssembly()
+            .GetManifestResourceStream(descriptor.SolutionIdentifier)) {
+            ElloumiCTAPSolutionParser slnParser = new ElloumiCTAPSolutionParser();
+            slnParser.Parse(solStream, instance.MemoryRequirements.Length);
+            if (slnParser.Error != null) throw slnParser.Error;
+
+            instance.BestKnownAssignment = slnParser.Assignment;
+            instance.BestKnownQuality = slnParser.Quality;
+          }
+        }
+      }
+      return instance;
+    }
+
+    private string GetPrettyName(string instanceIdentifier) {
+      return Regex.Match(instanceIdentifier, GetType().Namespace + @"\.Data\.(.*)\.dat").Groups[1].Captures[0].Value;
+    }
+
+    private string GetDescription() {
+      return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs	(revision 7445)
@@ -0,0 +1,124 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.IO;
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  public class ElloumiCTAPParser {
+    public int Tasks { get; private set; }
+    public int Processors { get; private set; }
+    public double[,] ExecutionCosts { get; private set; }
+    public double[,] CommunicationCosts { get; private set; }
+    public double[] MemoryRequirements { get; private set; }
+    public double[] MemoryCapacities { get; private set; }
+    public Exception Error { get; private set; }
+
+    public ElloumiCTAPParser() {
+      Reset();
+    }
+
+    public void Reset() {
+      Tasks = 0;
+      Processors = 0;
+      ExecutionCosts = null;
+      CommunicationCosts = null;
+      MemoryRequirements = null;
+      MemoryCapacities = null;
+      Error = null;
+    }
+
+    public bool Parse(string file) {
+      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
+        return Parse(stream);
+      }
+    }
+
+    /// <summary>
+    /// Reads from the given stream data which is expected to be in the Elloumi's CTAP format.
+    /// </summary>
+    /// <remarks>
+    /// The stream is not closed or disposed. The caller has to take care of that.
+    /// </remarks>
+    /// <param name="stream">The stream to read data from.</param>
+    /// <returns>True if the file was successfully read or false otherwise.</returns>
+    public bool Parse(Stream stream) {
+      Error = null;
+      var separator = new char[] { ' ', '\t' };
+      try {
+        StreamReader reader = new StreamReader(stream);
+        string line = Continue(reader);
+
+        Tasks = int.Parse(line);
+
+        line = Continue(reader);
+
+        Processors = int.Parse(line);
+
+        line = Continue(reader);
+
+        ExecutionCosts = new double[Processors, Tasks];
+        for (int i = 0; i < Processors; i++) {
+          string[] costsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+          for (int j = 0; j < Tasks; j++)
+            ExecutionCosts[i, j] = double.Parse(costsPerTask[j], CultureInfo.InvariantCulture.NumberFormat);
+          line = Continue(reader);
+        }
+
+        CommunicationCosts = new double[Tasks, Tasks];
+        for (int i = 0; i < Tasks - 1; i++) {
+          string[] costsTaskToTasks = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+          for (int j = i + 1; j < Tasks; j++) {
+            CommunicationCosts[i, j] = double.Parse(costsTaskToTasks[j], CultureInfo.InvariantCulture.NumberFormat);
+            CommunicationCosts[j, i] = CommunicationCosts[i, j];
+          }
+          line = Continue(reader);
+        }
+
+        MemoryRequirements = new double[Tasks];
+        string[] requirementsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int i = 0; i < Tasks; i++)
+          MemoryRequirements[i] = double.Parse(requirementsPerTask[i], CultureInfo.InvariantCulture.NumberFormat);
+
+        line = Continue(reader);
+
+        MemoryCapacities = new double[Processors];
+        string[] capacitiesPerProcessor = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int i = 0; i < Processors; i++)
+          MemoryCapacities[i] = double.Parse(capacitiesPerProcessor[i], CultureInfo.InvariantCulture.NumberFormat);
+
+        return true;
+      } catch (Exception e) {
+        Error = e;
+        return false;
+      }
+    }
+
+    private static string Continue(StreamReader reader) {
+      string line = String.Empty;
+      while (String.IsNullOrEmpty(line) && !reader.EndOfStream) {
+        line = reader.ReadLine();
+      }
+      return line;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPSolutionParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPSolutionParser.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPSolutionParser.cs	(revision 7445)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.IO;
+
+namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
+  public class ElloumiCTAPSolutionParser {
+    public int[] Assignment { get; private set; }
+    public double Quality { get; private set; }
+    public Exception Error { get; private set; }
+
+    public ElloumiCTAPSolutionParser() {
+      Reset();
+    }
+
+    public void Reset() {
+      Assignment = null;
+      Quality = double.NaN;
+      Error = null;
+    }
+
+    public bool Parse(string file, int tasks) {
+      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
+        return Parse(stream, tasks);
+      }
+    }
+
+    public bool Parse(Stream stream, int tasks) {
+      Error = null;
+      try {
+        StreamReader reader = new StreamReader(stream);
+        char[] delim = new char[] { ' ', '\t' };
+
+        string line = Continue(reader);
+        Assignment = new int[tasks];
+        for (int i = 0; i < tasks; i++) {
+          string[] assign = line.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+          Assignment[int.Parse(assign[0])] = int.Parse(assign[1]);
+          line = Continue(reader);
+        }
+
+        Quality = double.Parse(line.Trim(), CultureInfo.InvariantCulture.NumberFormat);
+
+        return true;
+      } catch (Exception e) {
+        Error = e;
+        return false;
+      }
+    }
+
+    private static string Continue(StreamReader reader) {
+      string line = String.Empty;
+      while (String.IsNullOrEmpty(line) && !reader.EndOfStream) {
+        line = reader.ReadLine();
+      }
+      return line;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7445)
@@ -46,5 +46,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="SolutionParser.cs" />
+    <Compile Include="ElloumiCTAPSolutionParser.cs" />
     <EmbeddedResource Include="Data\tass1003Aa.dat" />
     <EmbeddedResource Include="Data\tass1003Ab.dat" />
@@ -130,8 +130,8 @@
     <EmbeddedResource Include="Data\tassc2005De.dat" />
     <None Include="Plugin.cs.frame" />
-    <Compile Include="Instance.cs" />
-    <Compile Include="InstanceDescriptor.cs" />
-    <Compile Include="InstanceProvider.cs" />
-    <Compile Include="Parser.cs" />
+    <Compile Include="ElloumiCTAPInstance.cs" />
+    <Compile Include="ElloumiCTAPInstanceDescriptor.cs" />
+    <Compile Include="ElloumiCTAPInstanceProvider.cs" />
+    <Compile Include="ElloumiCTAPParser.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Instance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Instance.cs	(revision 7444)
+++ 	(revision )
@@ -1,33 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  internal class Instance : ICTAPInstance {
-    public string Name { get; internal set; }
-    public string Description { get; internal set; }
-    public double[,] ExecutionCosts { get; internal set; }
-    public double[,] CommunicationCosts { get; internal set; }
-    public double[] MemoryRequirements { get; internal set; }
-    public double[] MemoryCapacities { get; internal set; }
-    public int[] BestKnownAssignment { get; internal set; }
-    public double BestKnownQuality { get; internal set; }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/InstanceDescriptor.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/InstanceDescriptor.cs	(revision 7444)
+++ 	(revision )
@@ -1,37 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  internal class InstanceDescriptor : IInstanceDescriptor {
-    public string Name { get; internal set; }
-    public string Description { get; internal set; }
-
-    internal string InstanceIdentifier { get; set; }
-    internal string SolutionIdentifier { get; set; }
-
-    internal InstanceDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
-      this.Name = name;
-      this.Description = description;
-      this.InstanceIdentifier = instanceIdentifier;
-      this.SolutionIdentifier = solutionIdentifier;
-    }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/InstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/InstanceProvider.cs	(revision 7444)
+++ 	(revision )
@@ -1,95 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
-using System.Reflection;
-using System.Text.RegularExpressions;
-
-namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  public class InstanceProvider : IProblemInstanceProvider<ICTAPInstance> {
-    public string Name {
-      get { return "Elloumi's CTAP instances"; }
-    }
-
-    public string Description {
-      get { return "CTAP instances published by Sourour Elloumi"; }
-    }
-
-    public Uri Link {
-      get { return new Uri("http://cedric.cnam.fr/oc/TAP/TAP.html"); }
-    }
-
-    public IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
-      var solutions = Assembly.GetExecutingAssembly()
-        .GetManifestResourceNames()
-        .Where(x => x.EndsWith(".sol"))
-        .ToDictionary(x => Path.GetFileNameWithoutExtension(x) + ".dat", x => x);
-
-      return Assembly.GetExecutingAssembly()
-          .GetManifestResourceNames()
-          .Where(x => x.EndsWith(".dat"))
-          .OrderBy(x => x)
-          .Select(x => new InstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
-    }
-
-    public ICTAPInstance GetInstance(IInstanceDescriptor id) {
-      var descriptor = (InstanceDescriptor)id;
-      var instance = new Instance();
-      using (var stream = Assembly.GetExecutingAssembly()
-        .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        Parser datParser = new Parser();
-        datParser.Parse(stream);
-        if (datParser.Error != null) throw datParser.Error;
-        instance.ExecutionCosts = datParser.ExecutionCosts;
-        instance.CommunicationCosts = datParser.CommunicationCosts;
-        instance.MemoryRequirements = datParser.MemoryRequirements;
-        instance.MemoryCapacities = datParser.MemoryCapacities;
-
-        instance.Name = id.Name;
-        instance.Description = id.Description;
-
-        if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
-          using (Stream solStream = Assembly.GetExecutingAssembly()
-            .GetManifestResourceStream(descriptor.SolutionIdentifier)) {
-            SolutionParser slnParser = new SolutionParser();
-            slnParser.Parse(solStream, instance.MemoryRequirements.Length);
-            if (slnParser.Error != null) throw slnParser.Error;
-
-            instance.BestKnownAssignment = slnParser.Assignment;
-            instance.BestKnownQuality = slnParser.Quality;
-          }
-        }
-      }
-      return instance;
-    }
-
-    private string GetPrettyName(string instanceIdentifier) {
-      return Regex.Match(instanceIdentifier, GetType().Namespace + @"\.Data\.(.*)\.dat").Value;
-    }
-
-    private string GetDescription() {
-      return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
-    }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Parser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Parser.cs	(revision 7444)
+++ 	(revision )
@@ -1,124 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Globalization;
-using System.IO;
-
-namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  public class Parser {
-    public int Tasks { get; private set; }
-    public int Processors { get; private set; }
-    public double[,] ExecutionCosts { get; private set; }
-    public double[,] CommunicationCosts { get; private set; }
-    public double[] MemoryRequirements { get; private set; }
-    public double[] MemoryCapacities { get; private set; }
-    public Exception Error { get; private set; }
-
-    public Parser() {
-      Reset();
-    }
-
-    public void Reset() {
-      Tasks = 0;
-      Processors = 0;
-      ExecutionCosts = null;
-      CommunicationCosts = null;
-      MemoryRequirements = null;
-      MemoryCapacities = null;
-      Error = null;
-    }
-
-    public bool Parse(string file) {
-      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream);
-      }
-    }
-
-    /// <summary>
-    /// Reads from the given stream data which is expected to be in the Elloumi's CTAP format.
-    /// </summary>
-    /// <remarks>
-    /// The stream is not closed or disposed. The caller has to take care of that.
-    /// </remarks>
-    /// <param name="stream">The stream to read data from.</param>
-    /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream) {
-      Error = null;
-      var separator = new char[] { ' ', '\t' };
-      try {
-        StreamReader reader = new StreamReader(stream);
-        string line = Continue(reader);
-
-        Tasks = int.Parse(line);
-
-        line = Continue(reader);
-
-        Processors = int.Parse(line);
-
-        line = Continue(reader);
-
-        ExecutionCosts = new double[Tasks, Processors];
-        for (int i = 0; i < Processors; i++) {
-          string[] costsPerTask = line.Split(separator);
-          for (int j = 0; j < Tasks; j++)
-            ExecutionCosts[i, j] = double.Parse(costsPerTask[j], CultureInfo.InvariantCulture.NumberFormat);
-          line = Continue(reader);
-        }
-
-        CommunicationCosts = new double[Tasks, Tasks];
-        for (int i = 0; i < Tasks - 1; i++) {
-          string[] costsTaskToTasks = line.Split(separator);
-          for (int j = i + 1; j < Tasks; j++) {
-            CommunicationCosts[i, j] = double.Parse(costsTaskToTasks[j], CultureInfo.InvariantCulture.NumberFormat);
-            CommunicationCosts[j, i] = CommunicationCosts[i, j];
-          }
-          line = Continue(reader);
-        }
-
-        MemoryRequirements = new double[Tasks];
-        string[] requirementsPerTask = line.Split(separator);
-        for (int i = 0; i < Tasks; i++)
-          MemoryRequirements[i] = double.Parse(requirementsPerTask[i], CultureInfo.InvariantCulture.NumberFormat);
-
-        line = Continue(reader);
-
-        MemoryCapacities = new double[Processors];
-        string[] capacitiesPerProcessor = line.Split(separator);
-        for (int i = 0; i < Processors; i++)
-          MemoryCapacities[i] = double.Parse(capacitiesPerProcessor[i], CultureInfo.InvariantCulture.NumberFormat);
-
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
-    }
-
-    private static string Continue(StreamReader reader) {
-      string line = String.Empty;
-      while (String.IsNullOrEmpty(line) && !reader.EndOfStream) {
-        line = reader.ReadLine();
-      }
-      return line;
-    }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/SolutionParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/SolutionParser.cs	(revision 7444)
+++ 	(revision )
@@ -1,79 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Globalization;
-using System.IO;
-
-namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  public class SolutionParser {
-    public int[] Assignment { get; private set; }
-    public double Quality { get; private set; }
-    public Exception Error { get; private set; }
-
-    public SolutionParser() {
-      Reset();
-    }
-
-    public void Reset() {
-      Assignment = null;
-      Quality = double.NaN;
-      Error = null;
-    }
-
-    public bool Parse(string file, int tasks) {
-      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream, tasks);
-      }
-    }
-
-    public bool Parse(Stream stream, int tasks) {
-      Error = null;
-      try {
-        StreamReader reader = new StreamReader(stream);
-        char[] delim = new char[] { ' ', '\t' };
-
-        string line = Continue(reader);
-        Assignment = new int[tasks];
-        for (int i = 0; i < tasks; i++) {
-          string[] assign = line.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          Assignment[int.Parse(assign[0])] = int.Parse(assign[1]);
-          line = Continue(reader);
-        }
-
-        Quality = double.Parse(line.Trim(), CultureInfo.InvariantCulture.NumberFormat);
-
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
-    }
-
-    private static string Continue(StreamReader reader) {
-      string line = String.Empty;
-      while (String.IsNullOrEmpty(line) && !reader.EndOfStream) {
-        line = reader.ReadLine();
-      }
-      return line;
-    }
-  }
-}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7445)
@@ -47,9 +47,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Parser.cs" />
-    <Compile Include="Instance.cs" />
-    <Compile Include="InstanceDescriptor.cs" />
-    <Compile Include="SolutionParser.cs" />
-    <Compile Include="InstanceProvider.cs" />
+    <Compile Include="QAPLIBParser.cs" />
+    <Compile Include="QAPLIBInstance.cs" />
+    <Compile Include="QAPLIBInstanceDescriptor.cs" />
+    <Compile Include="QAPLIBSolutionParser.cs" />
+    <Compile Include="QAPLIBInstanceProvider.cs" />
     <EmbeddedResource Include="Data\bur26a.dat" />
     <EmbeddedResource Include="Data\bur26b.dat" />
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Instance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Instance.cs	(revision 7444)
+++ 	(revision )
@@ -1,31 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Instances.QAPLIB {
-  internal class Instance : IQAPInstance {
-    public string Name { get; set; }
-    public string Description { get; set; }
-    public double[,] Distances { get; set; }
-    public double[,] Weights { get; set; }
-    public int[] BestKnownAssignment { get; set; }
-    public double BestKnownQuality { get; set; }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/InstanceDescriptor.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/InstanceDescriptor.cs	(revision 7444)
+++ 	(revision )
@@ -1,37 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Instances.QAPLIB {
-  internal class InstanceDescriptor : IInstanceDescriptor {
-    public string Name { get; internal set; }
-    public string Description { get; internal set; }
-
-    internal string InstanceIdentifier { get; set; }
-    internal string SolutionIdentifier { get; set; }
-
-    internal InstanceDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
-      this.Name = name;
-      this.Description = description;
-      this.InstanceIdentifier = instanceIdentifier;
-      this.SolutionIdentifier = solutionIdentifier;
-    }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/InstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/InstanceProvider.cs	(revision 7444)
+++ 	(revision )
@@ -1,93 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
-using System.Reflection;
-using System.Text.RegularExpressions;
-
-namespace HeuristicLab.Problems.Instances.QAPLIB {
-  public class InstanceProvider : IProblemInstanceProvider<IQAPInstance> {
-    public string Name {
-      get { return "QAPLIB"; }
-    }
-
-    public string Description {
-      get { return "Quadratic Assignment Problem Library"; }
-    }
-
-    public Uri Link {
-      get { return new Uri("http://www.seas.upenn.edu/qaplib/"); }
-    }
-
-    public IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
-      var solutions = Assembly.GetExecutingAssembly()
-        .GetManifestResourceNames()
-        .Where(x => x.EndsWith(".sln"))
-        .ToDictionary(x => Path.GetFileNameWithoutExtension(x) + ".dat", x => x);
-
-      return Assembly.GetExecutingAssembly()
-          .GetManifestResourceNames()
-          .Where(x => x.EndsWith(".dat"))
-          .OrderBy(x => x)
-          .Select(x => new InstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
-    }
-
-    public IQAPInstance GetInstance(IInstanceDescriptor id) {
-      var descriptor = (InstanceDescriptor)id;
-      var instance = new Instance();
-      using (var stream = Assembly.GetExecutingAssembly()
-        .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        Parser datParser = new Parser();
-        datParser.Parse(stream);
-        if (datParser.Error != null) throw datParser.Error;
-        instance.Distances = datParser.Distances;
-        instance.Weights = datParser.Weights;
-
-        instance.Name = id.Name;
-        instance.Description = id.Description;
-
-        if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
-          using (Stream solStream = Assembly.GetExecutingAssembly()
-            .GetManifestResourceStream(descriptor.SolutionIdentifier)) {
-            SolutionParser slnParser = new SolutionParser();
-            slnParser.Parse(solStream, true);
-            if (slnParser.Error != null) throw slnParser.Error;
-
-            instance.BestKnownAssignment = slnParser.Assignment;
-            instance.BestKnownQuality = slnParser.Quality;
-          }
-        }
-      }
-      return instance;
-    }
-
-    private string GetPrettyName(string instanceIdentifier) {
-      return Regex.Match(instanceIdentifier, GetType().Namespace + @"\.Data\.(.*)\.dat").Value;
-    }
-
-    private string GetDescription() {
-      return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
-    }
-  }
-}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Parser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Parser.cs	(revision 7444)
+++ 	(revision )
@@ -1,105 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.IO;
-
-namespace HeuristicLab.Problems.Instances.QAPLIB {
-  public class Parser {
-    public int Size { get; private set; }
-    public double[,] Distances { get; private set; }
-    public double[,] Weights { get; private set; }
-    public Exception Error { get; private set; }
-
-    public Parser() {
-      Reset();
-    }
-
-    public void Reset() {
-      Size = 0;
-      Distances = null;
-      Weights = null;
-      Error = null;
-    }
-
-    public bool Parse(string file) {
-      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream);
-      }
-    }
-
-    /// <summary>
-    /// Reads from the given stream data which is expected to be in the QAPLIB format.
-    /// </summary>
-    /// <remarks>
-    /// The stream is not closed or disposed. The caller has to take care of that.
-    /// </remarks>
-    /// <param name="stream">The stream to read data from.</param>
-    /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream) {
-      Error = null;
-      try {
-        StreamReader reader = new StreamReader(stream);
-        Size = int.Parse(reader.ReadLine());
-        Distances = new double[Size, Size];
-        Weights = new double[Size, Size];
-        string valLine = null;
-        char[] delim = new char[] { ' ' };
-        int read = 0;
-        int k = 0;
-        while (k < Size) {
-          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading first matrix.");
-          valLine = reader.ReadLine();
-          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
-          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          foreach (string val in vals) {
-            Weights[k, read++] = double.Parse(val);
-            if (read == Size) {
-              read = 0;
-              k++;
-            }
-          }
-        }
-
-        read = 0;
-        k = 0;
-
-        while (k < Size) {
-          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading second matrix.");
-          valLine = reader.ReadLine();
-          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
-          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          foreach (string val in vals) {
-            Distances[k, read++] = double.Parse(val);
-            if (read == Size) {
-              read = 0;
-              k++;
-            }
-          }
-        }
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
-    }
-  }
-}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs	(revision 7445)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances {
-  [Plugin("HeuristicLab.Problems.Instances.QAPLIB", "3.3.6.7443")]
+  [Plugin("HeuristicLab.Problems.Instances.QAPLIB", "3.3.6.7444")]
   [PluginFile("HeuristicLab.Problems.Instances.QAPLIB-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsInstancesQAPLIBPlugin : PluginBase {
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstance.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstance.cs	(revision 7445)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  internal class QAPLIBInstance : IQAPInstance {
+    public string Name { get; set; }
+    public string Description { get; set; }
+    public double[,] Distances { get; set; }
+    public double[,] Weights { get; set; }
+    public int[] BestKnownAssignment { get; set; }
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceDescriptor.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceDescriptor.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceDescriptor.cs	(revision 7445)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  internal class QAPLIBInstanceDescriptor : IInstanceDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+    internal string SolutionIdentifier { get; set; }
+
+    internal QAPLIBInstanceDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+      this.SolutionIdentifier = solutionIdentifier;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7445)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Reflection;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  public class QAPLIBInstanceProvider : IProblemInstanceProvider<IQAPInstance> {
+    public string Name {
+      get { return "QAPLIB"; }
+    }
+
+    public string Description {
+      get { return "Quadratic Assignment Problem Library"; }
+    }
+
+    public Uri Link {
+      get { return new Uri("http://www.seas.upenn.edu/qaplib/"); }
+    }
+
+    public IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+      var solutions = Assembly.GetExecutingAssembly()
+        .GetManifestResourceNames()
+        .Where(x => x.EndsWith(".sln"))
+        .ToDictionary(x => Path.GetFileNameWithoutExtension(x) + ".dat", x => x);
+
+      return Assembly.GetExecutingAssembly()
+          .GetManifestResourceNames()
+          .Where(x => x.EndsWith(".dat"))
+          .OrderBy(x => x)
+          .Select(x => new QAPLIBInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+    }
+
+    public IQAPInstance GetInstance(IInstanceDescriptor id) {
+      var descriptor = (QAPLIBInstanceDescriptor)id;
+      var instance = new QAPLIBInstance();
+      using (var stream = Assembly.GetExecutingAssembly()
+        .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
+        QAPLIBParser datParser = new QAPLIBParser();
+        datParser.Parse(stream);
+        if (datParser.Error != null) throw datParser.Error;
+        instance.Distances = datParser.Distances;
+        instance.Weights = datParser.Weights;
+
+        instance.Name = id.Name;
+        instance.Description = id.Description;
+
+        if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
+          using (Stream solStream = Assembly.GetExecutingAssembly()
+            .GetManifestResourceStream(descriptor.SolutionIdentifier)) {
+            QAPLIBSolutionParser slnParser = new QAPLIBSolutionParser();
+            slnParser.Parse(solStream, true);
+            if (slnParser.Error != null) throw slnParser.Error;
+
+            instance.BestKnownAssignment = slnParser.Assignment;
+            instance.BestKnownQuality = slnParser.Quality;
+          }
+        }
+      }
+      return instance;
+    }
+
+    private string GetPrettyName(string instanceIdentifier) {
+      return Regex.Match(instanceIdentifier, GetType().Namespace + @"\.Data\.(.*)\.dat").Groups[1].Captures[0].Value;
+    }
+
+    private string GetDescription() {
+      return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs	(revision 7445)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  public class QAPLIBParser {
+    public int Size { get; private set; }
+    public double[,] Distances { get; private set; }
+    public double[,] Weights { get; private set; }
+    public Exception Error { get; private set; }
+
+    public QAPLIBParser() {
+      Reset();
+    }
+
+    public void Reset() {
+      Size = 0;
+      Distances = null;
+      Weights = null;
+      Error = null;
+    }
+
+    public bool Parse(string file) {
+      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
+        return Parse(stream);
+      }
+    }
+
+    /// <summary>
+    /// Reads from the given stream data which is expected to be in the QAPLIB format.
+    /// </summary>
+    /// <remarks>
+    /// The stream is not closed or disposed. The caller has to take care of that.
+    /// </remarks>
+    /// <param name="stream">The stream to read data from.</param>
+    /// <returns>True if the file was successfully read or false otherwise.</returns>
+    public bool Parse(Stream stream) {
+      Error = null;
+      try {
+        StreamReader reader = new StreamReader(stream);
+        Size = int.Parse(reader.ReadLine());
+        Distances = new double[Size, Size];
+        Weights = new double[Size, Size];
+        string valLine = null;
+        char[] delim = new char[] { ' ' };
+        int read = 0;
+        int k = 0;
+        while (k < Size) {
+          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading first matrix.");
+          valLine = reader.ReadLine();
+          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
+          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+          foreach (string val in vals) {
+            Weights[k, read++] = double.Parse(val);
+            if (read == Size) {
+              read = 0;
+              k++;
+            }
+          }
+        }
+
+        read = 0;
+        k = 0;
+
+        while (k < Size) {
+          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading second matrix.");
+          valLine = reader.ReadLine();
+          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
+          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+          foreach (string val in vals) {
+            Distances[k, read++] = double.Parse(val);
+            if (read == Size) {
+              read = 0;
+              k++;
+            }
+          }
+        }
+        return true;
+      } catch (Exception e) {
+        Error = e;
+        return false;
+      }
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBSolutionParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBSolutionParser.cs	(revision 7445)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBSolutionParser.cs	(revision 7445)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.IO;
+
+namespace HeuristicLab.Problems.Instances.QAPLIB {
+  public class QAPLIBSolutionParser {
+    public int Size { get; private set; }
+    public int[] Assignment { get; private set; }
+    public double Quality { get; private set; }
+    public Exception Error { get; private set; }
+
+    public QAPLIBSolutionParser() {
+      Reset();
+    }
+
+    public void Reset() {
+      Size = 0;
+      Assignment = null;
+      Quality = double.NaN;
+      Error = null;
+    }
+
+    /// <summary>
+    /// Reads from the given stream data which is expected to be in the QAPLIB solution format.
+    /// 
+    /// The QAPLIB solution file format (.sln) is as follows:
+    /// First line: Size of the permutation followed by a blank followed by the quality formatted using no thousands separator and if a fractional number with the "." as decimal symbol
+    /// Remaining lines: The values of the permutation separated by blanks. Values must lie in the range [1;size of the permutation].
+    /// </summary>
+    /// <param name="file">The file to read data from.</param>
+    /// <param name="valueAsLocation">The numbers can be interpreted either as facilities or locations.
+    /// HeuristicLab always encodes the permutation such that the index denotes the facility and the value the location.
+    /// If this parameter is true, then the permutation is expected to follow this encoding.
+    /// If this parameter is false, the meaning of value and index will be swapped when reading the permutation.</param>
+    /// <returns></returns>
+    public bool Parse(string file, bool valueAsLocation) {
+      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
+        return Parse(stream, valueAsLocation);
+      }
+    }
+
+    /// <summary>
+    /// Reads from the given stream data which is expected to be in the QAPLIB solution format.
+    /// 
+    /// The QAPLIB solution file format (.sln) is as follows:
+    /// First line: Size of the permutation followed by a blank followed by the quality formatted using no thousands separator and if a fractional number with the "." as decimal symbol
+    /// Remaining lines: The values of the permutation separated by blanks. Values must lie in the range [1;size of the permutation].
+    /// </summary>
+    /// <remarks>
+    /// The stream is not closed or disposed. The caller has to take care of that.
+    /// </remarks>
+    /// <param name="stream">The stream to read data from.</param>
+    /// <param name="valueAsLocation">The numbers can be interpreted either as facilities or locations.
+    /// HeuristicLab always encodes the permutation such that the index denotes the facility and the value the location.
+    /// If this parameter is true, then the permutation is expected to follow this encoding.
+    /// If this parameter is false, the meaning of value and index will be swapped when reading the permutation.</param>
+    /// <returns>True if the file was successfully read or false otherwise.</returns>
+    public bool Parse(Stream stream, bool valueAsLocation) {
+      Error = null;
+      try {
+        StreamReader reader = new StreamReader(stream);
+        char[] delim = new char[] { ' ', ',' }; // comma is added for nug30.sln which is the only file that separates the permutation with commas
+        string[] firstline = reader.ReadLine().Split(delim, StringSplitOptions.RemoveEmptyEntries);
+        Size = int.Parse(firstline[0]);
+        Quality = double.Parse(firstline[1], CultureInfo.InvariantCulture.NumberFormat);
+        Assignment = new int[Size];
+        int read = 0;
+        while (!reader.EndOfStream) {
+          string valLine = reader.ReadLine();
+          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+          for (int j = 0; j < vals.Length; j++) {
+            if (valueAsLocation)
+              Assignment[int.Parse(vals[j]) - 1] = read++;
+            else Assignment[read++] = int.Parse(vals[j]) - 1;
+          }
+        }
+        return true;
+      } catch (Exception e) {
+        Error = e;
+        return false;
+      }
+    }
+  }
+}
Index: anches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/SolutionParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/SolutionParser.cs	(revision 7444)
+++ 	(revision )
@@ -1,105 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Globalization;
-using System.IO;
-
-namespace HeuristicLab.Problems.Instances.QAPLIB {
-  public class SolutionParser {
-    public int Size { get; private set; }
-    public int[] Assignment { get; private set; }
-    public double Quality { get; private set; }
-    public Exception Error { get; private set; }
-
-    public SolutionParser() {
-      Reset();
-    }
-
-    public void Reset() {
-      Size = 0;
-      Assignment = null;
-      Quality = double.NaN;
-      Error = null;
-    }
-
-    /// <summary>
-    /// Reads from the given stream data which is expected to be in the QAPLIB solution format.
-    /// 
-    /// The QAPLIB solution file format (.sln) is as follows:
-    /// First line: Size of the permutation followed by a blank followed by the quality formatted using no thousands separator and if a fractional number with the "." as decimal symbol
-    /// Remaining lines: The values of the permutation separated by blanks. Values must lie in the range [1;size of the permutation].
-    /// </summary>
-    /// <param name="file">The file to read data from.</param>
-    /// <param name="valueAsLocation">The numbers can be interpreted either as facilities or locations.
-    /// HeuristicLab always encodes the permutation such that the index denotes the facility and the value the location.
-    /// If this parameter is true, then the permutation is expected to follow this encoding.
-    /// If this parameter is false, the meaning of value and index will be swapped when reading the permutation.</param>
-    /// <returns></returns>
-    public bool Parse(string file, bool valueAsLocation) {
-      using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream, valueAsLocation);
-      }
-    }
-
-    /// <summary>
-    /// Reads from the given stream data which is expected to be in the QAPLIB solution format.
-    /// 
-    /// The QAPLIB solution file format (.sln) is as follows:
-    /// First line: Size of the permutation followed by a blank followed by the quality formatted using no thousands separator and if a fractional number with the "." as decimal symbol
-    /// Remaining lines: The values of the permutation separated by blanks. Values must lie in the range [1;size of the permutation].
-    /// </summary>
-    /// <remarks>
-    /// The stream is not closed or disposed. The caller has to take care of that.
-    /// </remarks>
-    /// <param name="stream">The stream to read data from.</param>
-    /// <param name="valueAsLocation">The numbers can be interpreted either as facilities or locations.
-    /// HeuristicLab always encodes the permutation such that the index denotes the facility and the value the location.
-    /// If this parameter is true, then the permutation is expected to follow this encoding.
-    /// If this parameter is false, the meaning of value and index will be swapped when reading the permutation.</param>
-    /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream, bool valueAsLocation) {
-      Error = null;
-      try {
-        StreamReader reader = new StreamReader(stream);
-        char[] delim = new char[] { ' ', ',' }; // comma is added for nug30.sln which is the only file that separates the permutation with commas
-        string[] firstline = reader.ReadLine().Split(delim, StringSplitOptions.RemoveEmptyEntries);
-        Size = int.Parse(firstline[0]);
-        Quality = double.Parse(firstline[1], CultureInfo.InvariantCulture.NumberFormat);
-        Assignment = new int[Size];
-        int read = 0;
-        while (!reader.EndOfStream) {
-          string valLine = reader.ReadLine();
-          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = 0; j < vals.Length; j++) {
-            if (valueAsLocation)
-              Assignment[int.Parse(vals[j]) - 1] = read++;
-            else Assignment[read++] = int.Parse(vals[j]) - 1;
-          }
-        }
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
-    }
-  }
-}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7445)
@@ -40,8 +40,4 @@
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core-3.3">
-      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs	(revision 7445)
@@ -24,5 +24,5 @@
 
 namespace HeuristicLab.Problems.Instances {
-  public interface IProblemInstanceProvider<TInstance> {
+  public interface IProblemInstanceProvider {
     string Name { get; }
     string Description { get; }
@@ -30,4 +30,7 @@
 
     IEnumerable<IInstanceDescriptor> GetInstanceDescriptors();
+  }
+
+  public interface IProblemInstanceProvider<TInstance> : IProblemInstanceProvider {
     TInstance GetInstance(IInstanceDescriptor descriptor);
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/ICTAPInstance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/ICTAPInstance.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/ICTAPInstance.cs	(revision 7445)
@@ -55,5 +55,5 @@
     /// Optional! The quality value of the <see cref="BestKnownAssignment"/>
     /// </summary>
-    double BestKnownQuality { get; }
+    double? BestKnownQuality { get; }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/IQAPInstance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/IQAPInstance.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Instances/IQAPInstance.cs	(revision 7445)
@@ -47,5 +47,5 @@
     /// Optional! The quality value of the <see cref="BestKnownAssignment"/>
     /// </summary>
-    double BestKnownQuality { get; }
+    double? BestKnownQuality { get; }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Plugin.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Plugin.cs	(revision 7444)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Plugin.cs	(revision 7445)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances {
-  [Plugin("HeuristicLab.Problems.Instances", "3.3.6.7443")]
+  [Plugin("HeuristicLab.Problems.Instances", "3.3.6.7444")]
   [PluginFile("HeuristicLab.Problems.Instances-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsInstancesPlugin : PluginBase {
